/*
 * SoundsInfo.java
 *
 * Created on May 11, 2006, 11:54 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package raft.karga.sound;

import raft.karga.core.*;
import java.util.*;
/**
 *
 * @author hakan eryargi (r a f t)
 */
public class SoundsInfo implements java.io.Serializable {
    private static final long serialVersionUID = 1;
    
    public static final String SOUND_INFO_FILE_NAME = "sounds.info";
    
    public final String ambientSound = null;
    
    private transient ArrayList<Sound> tmpSounds;
    public final Map<String, Sound> sounds = new Util.SafeMap<String, Sound>();
    
    /**
     * Creates a new instance of SoundsInfo
     */
    public SoundsInfo() {
    }
    
    private void jibxPostSet() {
        for (Sound sound  : tmpSounds) 
            sounds.put(sound.name, sound);
        
        if ((ambientSound != null) && !sounds.containsKey(ambientSound))
             throw new IllegalStateException("ambient sound doesnt exist: " + ambientSound);
    }
    
    public String toString() {
        return "SoundInfo: " + sounds.size() + " sounds, ambient: " + ambientSound;
    }
    
    public static class Sound implements java.io.Serializable {
        private static final long serialVersionUID = 1;
        
        public final String name = null;
        public final String file = null;
        public float initialGain = 0f;
        
        public String toString() {
            return "Sound (" + name + "): " + file;
        }
    }
}
